SystemOrganization addCategory: #ImageFamilyTree!

Object subclass: #ImageFamilyTreeJudge
	instanceVariableNames: 'stream1 stream2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!ImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/14/2010 16:43'!
judgeResult

	^nil! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:42'!
stream1: aReadStream 

	stream1 := aReadStream! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:42'!
stream2: aReadStream 

	stream2 := aReadStream! !

Object subclass: #JudgeResultIFT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

JudgeResultIFT subclass: #AncestorJRIFT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

JudgeResultIFT subclass: #IdenticalJRIFT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

JudgeResultIFT subclass: #ShareCommonAncestorJRIFT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

TestCase subclass: #ImageFamilyTreeJudgeTest
	instanceVariableNames: 'stream1 stream2 judge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!ImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 16:40'!
test1IsAncestorOf2

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	judge := ImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	self assert: (judge judgeResult isKindOf: AncestorJRIFT).
	self assert: judge ancestor = 1.
	self assert: judge descendant = 2.! !

!ImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 16:40'!
test2IsAncestorOf1

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets.' readStream.

	judge := ImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	self assert: (judge judgeResult isKindOf: AncestorJRIFT).
	self assert: judge ancestor = 2.
	self assert: judge descendant = 1.! !

!ImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 16:35'!
testIdentical

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	judge := ImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	self assert: (judge judgeResult isKindOf: IdenticalJRIFT).! !

!ImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 16:38'!
testShareCommonAncestor

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Pluto' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Mars' readStream.

	judge := ImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	self assert: (judge judgeResult isKindOf: ShareCommonAncestorJRIFT)! !
